<?php

use App\Models\Expense;
use Illuminate\Database\Seeder;

class ExpensesTableSeeder extends Seeder
{
    /**
     * Run the database seeds.
     *
     * @return void
     */
    public function run()
    {
        $expenses = [
            [
                "id" => 1,
                "name" => "10 kilomètres parcourus",
                "amount" => 3.5,
                "type" => "debit",
                "executed_at" => "2022-06-01 00:00:00+00",
                "user_id" => 14,
                "loanable_id" => 1002,
                "expense_tag_id" => 1,
            ],
            [
                "id" => 2,
                "name" => "10 kilomètres parcourus",
                "amount" => 3.5,
                "type" => "debit",
                "executed_at" => "2022-06-03 00:00:00+00",
                "user_id" => 16,
                "loanable_id" => 1002,
                "expense_tag_id" => 1,
            ],
            [
                "id" => 3,
                "name" => "20 kilomètres parcourus",
                "amount" => 7,
                "type" => "debit",
                "executed_at" => "2022-06-04 00:00:00+00",
                "user_id" => 15,
                "loanable_id" => 1002,
                "expense_tag_id" => 1,
            ],
            [
                "id" => 4,
                "name" => "",
                "amount" => 15,
                "type" => "credit",
                "executed_at" => "2022-06-04 00:00:00+00",
                "user_id" => 15,
                "loanable_id" => 1002,
                "expense_tag_id" => 2,
            ],
            [
                "id" => 5,
                "name" => "15 kilomètres parcourus",
                "amount" => 3,
                "type" => "debit",
                "executed_at" => "2022-06-04 00:00:00+00",
                "user_id" => 15,
                "loanable_id" => 1003,
                "expense_tag_id" => 1,
            ],
            [
                "id" => 6,
                "name" => "10 kilomètres parcourus",
                "amount" => 2,
                "type" => "debit",
                "executed_at" => "2022-06-05 00:00:00+00",
                "user_id" => 14,
                "loanable_id" => 1003,
                "expense_tag_id" => 1,
            ],
            [
                "id" => 7,
                "name" => "",
                "amount" => 50,
                "type" => "credit",
                "executed_at" => "2022-06-05 00:00:00+00",
                "user_id" => 14,
                "loanable_id" => 1003,
                "expense_tag_id" => 2,
            ],
            [
                "id" => 8,
                "name" => "15 kilomètres parcourus",
                "amount" => 5.25,
                "type" => "debit",
                "executed_at" => "2022-06-08 00:00:00+00",
                "user_id" => 14,
                "loanable_id" => 1002,
                "expense_tag_id" => 1,
            ],
            [
                "id" => 9,
                "name" => "",
                "amount" => 20,
                "type" => "credit",
                "executed_at" => "2022-06-08 00:00:00+00",
                "user_id" => 14,
                "loanable_id" => 1002,
                "expense_tag_id" => 2,
            ],
            [
                "id" => 10,
                "name" => "30 kilomètres parcourus",
                "amount" => 10.5,
                "type" => "debit",
                "executed_at" => "2022-06-11 00:00:00+00",
                "user_id" => 14,
                "loanable_id" => 1002,
                "expense_tag_id" => 1,
            ],
            [
                "id" => 11,
                "name" => "20 kilomètres parcourus",
                "amount" => 4,
                "type" => "debit",
                "executed_at" => "2022-06-14 00:00:00+00",
                "user_id" => 15,
                "loanable_id" => 1003,
                "expense_tag_id" => 1,
            ],
            [
                "id" => 12,
                "name" => "Assurance",
                "amount" => 50,
                "type" => "credit",
                "executed_at" => "2022-06-16 00:00:00+00",
                "user_id" => 14,
                "loanable_id" => 1002,
                "expense_tag_id" => 3,
            ],
            [
                "id" => 13,
                "name" => "Assurance",
                "amount" => 40,
                "type" => "credit",
                "executed_at" => "2022-06-22 00:00:00+00",
                "user_id" => 17,
                "loanable_id" => 1003,
                "expense_tag_id" => 3,
            ],
            [
                "id" => 14,
                "name" => "Provision entretien + Asssurance",
                "amount" => 25,
                "type" => "debit",
                "executed_at" => "2022-09-01 00:00:00+00",
                "user_id" => 14,
                "loanable_id" => 1002,
                "expense_tag_id" => 4,
                "locked" => true,
            ],
            [
                "id" => 15,
                "name" => "Provision entretien + Asssurance",
                "amount" => 25,
                "type" => "debit",
                "executed_at" => "2022-09-01 00:00:00+00",
                "user_id" => 15,
                "loanable_id" => 1002,
                "expense_tag_id" => 4,
                "locked" => true,
            ],
            [
                "id" => 16,
                "name" => "Provision entretien + Asssurance",
                "amount" => 25,
                "type" => "debit",
                "executed_at" => "2022-09-01 00:00:00+00",
                "user_id" => 16,
                "loanable_id" => 1002,
                "expense_tag_id" => 4,
                "locked" => true,
            ],
            [
                "id" => 17,
                "name" => "Provision entretien + Asssurance",
                "amount" => 25,
                "type" => "debit",
                "executed_at" => "2022-09-01 00:00:00+00",
                "user_id" => 17,
                "loanable_id" => 1002,
                "expense_tag_id" => 4,
                "locked" => true,
            ],
            [
                "id" => 18,
                "name" => "Achat boite à outil",
                "amount" => 50,
                "type" => "credit",
                "executed_at" => "2022-09-08 00:00:00+00",
                "user_id" => 15,
                "loanable_id" => 1003,
                "expense_tag_id" => 3,
            ],
            [
                "id" => 19,
                "name" => "10 kilomètres parcourus",
                "amount" => 3.5,
                "type" => "debit",
                "executed_at" => "2022-09-08 00:00:00+00",
                "user_id" => 15,
                "loanable_id" => 1002,
                "expense_tag_id" => 1,
            ],
            [
                "id" => 20,
                "name" => "",
                "amount" => 30,
                "type" => "credit",
                "executed_at" => "2022-09-08 00:00:00+00",
                "user_id" => 15,
                "loanable_id" => 1002,
                "expense_tag_id" => 2,
            ],
            [
                "id" => 21,
                "name" => "15 kilomètres parcourus",
                "amount" => 5.25,
                "type" => "debit",
                "executed_at" => "2022-12-14 00:00:00+00",
                "user_id" => 14,
                "loanable_id" => 1002,
                "expense_tag_id" => 1,
            ],
            [
                "id" => 22,
                "name" => "30 kilomètres parcourus",
                "amount" => 6,
                "type" => "debit",
                "executed_at" => "2022-12-14 00:00:00+00",
                "user_id" => 15,
                "loanable_id" => 1003,
                "expense_tag_id" => 1,
            ],
            [
                "id" => 23,
                "name" => "200 kilomètres parcourus",
                "amount" => 40,
                "type" => "debit",
                "executed_at" => "2022-12-20 00:00:00+00",
                "user_id" => 16,
                "loanable_id" => 1003,
                "expense_tag_id" => 1,
            ],
            [
                "id" => 24,
                "name" => "Provision pour entretien + Asssurance + boite à outils",
                "amount" => 32.5,
                "type" => "debit",
                "executed_at" => "2022-12-21 00:00:00+00",
                "user_id" => 14,
                "loanable_id" => 1003,
                "expense_tag_id" => 4,
                "locked" => true,
            ],
            [
                "id" => 25,
                "name" => "Provision pour entretien + Asssurance + boite à outils",
                "amount" => 32.5,
                "type" => "debit",
                "executed_at" => "2022-12-21 00:00:00+00",
                "user_id" => 15,
                "loanable_id" => 1003,
                "expense_tag_id" => 4,
                "locked" => true,
            ],
            [
                "id" => 26,
                "name" => "Provision pour entretien + Asssurance + boite à outils",
                "amount" => 32.5,
                "type" => "debit",
                "executed_at" => "2022-12-21 00:00:00+00",
                "user_id" => 16,
                "loanable_id" => 1003,
                "expense_tag_id" => 4,
                "locked" => true,
            ],
            [
                "id" => 27,
                "name" => "Provision pour entretien + Asssurance + boite à outils",
                "amount" => 32.5,
                "type" => "debit",
                "executed_at" => "2022-12-21 00:00:00+00",
                "user_id" => 17,
                "loanable_id" => 1003,
                "expense_tag_id" => 4,
                "locked" => true,
            ],
            [
                "id" => 28,
                "name" => "50 kilomètres parcourus",
                "amount" => 17.5,
                "type" => "debit",
                "executed_at" => "2022-12-20 00:00:00+00",
                "user_id" => 17,
                "loanable_id" => 1002,
                "expense_tag_id" => 1,
            ],
            [
                "id" => 29,
                "name" => "30 kilomètres parcourus",
                "amount" => 6,
                "type" => "debit",
                "executed_at" => "2022-12-21 00:00:00+00",
                "user_id" => 17,
                "loanable_id" => 1003,
                "expense_tag_id" => 1,
            ],
        ];

        foreach ($expenses as $expense) {
            if (!Expense::where("id", $expense["id"])->exists()) {
                Expense::create($expense);
            } else {
                Expense::where("id", $expense["id"])->update($expense);
            }
        }

        \DB::statement(
            "SELECT setval('expenses_id_seq'::regclass, (SELECT MAX(id) FROM expenses) + 1)"
        );
    }
}
